<div  class="miam-recipe-stepper">
  <div class="miam-recipe-stepper__padding">
    <button class="m-button-secondary" (click)="canceled.emit()">
      <ng-miam-icon [iconName]='icon.ChevronDown' primaryColor='var(--m-color-primary)' ></ng-miam-icon>
     <span>Retour</span> 
    </button>
  </div>
  <div #stepperLinks class="miam-recipe-stepper__links">
    <div class="miam-recipe-stepper__link" [ngClass]="{'active': currentStep === 0  }" (click)="scroolToAnchor(0)">
      <div class="miam-recipe-stepper__link__number">1</div>
      <span class="miam-recipe-stepper__link__name m-body-typo">Ma recette</span>
    </div>
    <div class="miam-recipe-stepper__link__divider"></div>
    <div class="miam-recipe-stepper__link" [ngClass]="{'active': currentStep === 1  }" (click)="scroolToAnchor(1)">
      <div class="miam-recipe-stepper__link__number" >2</div>
      <span class="miam-recipe-stepper__link__name m-body-typo">Description</span>
    </div>
    <div class="miam-recipe-stepper__link__divider"></div>
    <div class="miam-recipe-stepper__link" [ngClass]="{'active': currentStep === 2 }" (click)="scroolToAnchor(2)">
      <div class="miam-recipe-stepper__link__number" >3</div>
      <span class="miam-recipe-stepper__link__name m-body-typo">Ingrédients</span>
    </div>
  </div>
  <div class="miam-recipe-stepper__padding"></div>
  <ng-container *ngIf='recipeForm else loading' [formGroup]="recipeForm">
    <ng-container [formGroup]="recipeForm?.get('attributes')">
      <div #step class="miam-recipe-stepper__section">
        <div class="miam-recipe-stepper__mandatory">* champs obligatoire</div>
        <ng-miam-text-input class="m-title-text-input" ngDefaultControl
          [formControl]="recipeForm?.get('attributes')?.get('title')" placeholder="Titre de la recette">
        </ng-miam-text-input>
        <label>Ma recette est... <span>*</span> </label>
        <ng-miam-recipe-type-chooser ngDefaultControl [formControl]="recipeForm?.get('recipe-type')" ></ng-miam-recipe-type-chooser>
        <div class="miam-recipe-stepper__section__guests m-default-card">
          <span class="miam-recipe-stepper__guests__label">Nombre de convives</span>
          <ng-miam-counter-input ngDefaultControl formControlName="number-of-guests"
            (counterChange)="changeGuest($event)"
            [counter]="this.recipeForm?.get('attributes')?.get('number-of-guests').value" minRange='1'
            maxRange='999'>
          </ng-miam-counter-input>
        </div>
      </div>
      <div  #step class="miam-recipe-stepper__section">
        <div class="miam-recipe-stepper__section__row">
          <div class="miam-recipe-stepper__picture">
            <ng-miam-drag-drop-input ngDefaultControl
              [buttonText]="recipeForm?.get('attributes')?.get('media-url')?.value?.length > 0 ? 'Modifier la photo (2MB max)' :'Ajouter une photo (2MB max)'"
              [formControl]="recipeForm?.get('attributes')?.get('media-url')"
              [imageUrl]="recipeForm?.get('attributes')?.get('media-url')?.value" [photoMode]='true'
              (bigFileDropped)="displayBigFileWarning(true)" (onFileDropped)="displayBigFileWarning(false)">
            </ng-miam-drag-drop-input>
            <div class="miam-recipe-stepper__picture__warning" *ngIf="bigImageWarning">
              <ng-miam-icon [iconName]='icon.Warning' primaryColor='var(--m-color-warning-text)' ></ng-miam-icon>
              <span>Votre image est trop lourde (elle doit être inférieure à 2 Mo).  Merci d’en ajouter une plus légère. </span>
              <div class="miam-recipe-stepper__picture__warning__background"></div>
            </div>
          </div>
          <div class="miam-recipe-stepper__row__description">
            <h1 class="m-h1-typo">{{recipeForm?.get('attributes')?.get('title')?.value}}</h1>
            <label>Description de ma recette</label>
            <textarea cdkTextareaAutosize cdkAutosizeMinRows="20" cdkAutosizeMaxRows="50" class="m-input"
              [formControl]="recipeForm?.get('attributes')?.get('description')" maxlength="250"></textarea>
              <div class="miam-recipe-stepper__description__counter">{{recipeForm?.get('attributes')?.get('description')?.value?.length || 0}} <span>/ 250</span> </div>
            <!-- <label>Lien vidéo de ma recette (optionnel) :</label>
    <ng-miam-text-input  ngDefaultControl  placeholder=""></ng-miam-text-input> -->
          </div>
        </div>
        <div *ngIf='recipeForm' class="miam-recipe-stepper__section__times">
          <ng-miam-time-picker ngDefaultControl title='Temps de préparation'
            [formControl]="recipeForm?.get('attributes')?.get('preparation-time')" [icon]='icon.Time'>
          </ng-miam-time-picker>
          <ng-miam-time-picker ngDefaultControl title='Temps de cuisson'
            [formControl]="recipeForm?.get('attributes')?.get('cooking-time')" [icon]='icon.Hot'></ng-miam-time-picker>
          <ng-miam-time-picker ngDefaultControl title='Temps de repos'
            [formControl]="recipeForm?.get('attributes')?.get('resting-time')" [icon]='icon.Wait'></ng-miam-time-picker>
        </div>
        <div class="miam-recipe-stepper__attibutes__slider">
          <label>Niveau de difficulté de la recette</label>
          <ng-miam-slider ngDefaultControl [steps]="dificulties"
            [formControl]="recipeForm?.get('attributes')?.get('difficulty')" [icons]="iconsDificulties">
          </ng-miam-slider>
        </div>
      </div>
    </ng-container>
    <div #step  class="miam-recipe-stepper__section">
      <ng-miam-list-input  label="Ingrédients" ngDefaultControl
        (deleteId)="addToDeleteIngredientsList($event)" (orderHasChanged)='cdr.detectChanges()' [placeholder]='INGREDIENT_PLACEHOLDER' [ingredientMode]='true' [list]="recipeForm.get('ingredients')"
        formArrayName="ingredients" hint='ingrédients' [instructions]="INGREDIENT_INSTRUCTIONS">
      </ng-miam-list-input>
      <ng-miam-list-input  ngDefaultControl label="Étapes" formArrayName="steps" [placeholder]='STEP_PLACEHOLDER'
        (deleteId)="addToDeleteStepsList($event)" (orderHasChanged)='cdr.detectChanges()' [list]="recipeForm?.get('steps')" hint='étapes' [instructions]="STEP_INSTRUCTIONS"></ng-miam-list-input>
    </div>
  </ng-container>
  <ng-template #loading >
    <ng-miam-loader></ng-miam-loader>
  </ng-template>
  <div class="miam-recipe-stepper__footer">
    <button class="m-button-secondary" (click)='cancel()'>Annuler</button>
    <button class="m-button-primary" (click)='submit()' [disabled]='recipeForm?.invalid || !recipeForm?.dirty || isSubmiting'>
      Enregistrer la recette
    </button>
  </div>
</div>